'use strict';
module.exports = function generate_minItems(it) {
  var out = ' ';
  var $lvl = it.level,
    $dataLvl = it.dataLevel,
    $schema = it.schema['minItems'],
    $schemaPath = it.schemaPath + '.' + 'minItems',
    $errSchemaPath = it.errSchemaPath + '/' + 'minItems',
    $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || ''),
    $valid = 'valid' + $lvl,
    $errs = 'errs__' + $lvl;
  out += 'if (' + ($data) + '.length < ' + ($schema) + ') {  ';
  if (!it.compositeRule && $breakOnError) {
    out += ' validate.errors = [ '; /* istanbul ignore else */
    if (it.createErrors !== false) {
      out += ' { keyword: \'' + ('minItems') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: "' + ($errSchemaPath) + '" , params: { limit: ' + ($schema) + ' } ';
      if (it.opts.messages !== false) {
        out += ' , message: \'should NOT have less than ' + ($schema) + ' items\' ';
      }
      if (it.opts.verbose) {
        out += ' , schema: ' + ($schema) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' } ';
    } else {
      out += ' \'' + ('minItems') + '\' ';
    }
    out += ']; return false; ';
  } else {
    out += '  var err =   '; /* istanbul ignore else */
    if (it.createErrors !== false) {
      out += ' { keyword: \'' + ('minItems') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: "' + ($errSchemaPath) + '" , params: { limit: ' + ($schema) + ' } ';
      if (it.opts.messages !== false) {
        out += ' , message: \'should NOT have less than ' + ($schema) + ' items\' ';
      }
      if (it.opts.verbose) {
        out += ' , schema: ' + ($schema) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' } ';
    } else {
      out += ' \'' + ('minItems') + '\' ';
    }
    out += '; if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  }
  out += '} ';
  if ($breakOnError) {
    out += ' else { ';
  }
  return out;
}
