'use strict';
module.exports = function generate_pattern(it) {
  var out = ' ';
  var $lvl = it.level,
    $dataLvl = it.dataLevel,
    $schema = it.schema['pattern'],
    $schemaPath = it.schemaPath + '.' + 'pattern',
    $errSchemaPath = it.errSchemaPath + '/' + 'pattern',
    $breakOnError = !it.opts.allErrors;
  var $data = 'data' + ($dataLvl || ''),
    $valid = 'valid' + $lvl,
    $errs = 'errs__' + $lvl;
  new RegExp($schema);
  out += 'if (! ' + (it.usePattern($schema)) + '.test(' + ($data) + ') ) {  ';
  if (!it.compositeRule && $breakOnError) {
    out += ' validate.errors = [ '; /* istanbul ignore else */
    if (it.createErrors !== false) {
      out += ' { keyword: \'' + ('pattern') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: "' + ($errSchemaPath) + '" , params: { pattern: \'' + (it.util.escapeQuotes($schema)) + '\' } ';
      if (it.opts.messages !== false) {
        out += ' , message: \'should match pattern "' + (it.util.escapeQuotes($schema)) + '"\' ';
      }
      if (it.opts.verbose) {
        out += ' , schema: ' + (it.util.toQuotedString($schema)) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' } ';
    } else {
      out += ' \'' + ('pattern') + '\' ';
    }
    out += ']; return false; ';
  } else {
    out += '  var err =   '; /* istanbul ignore else */
    if (it.createErrors !== false) {
      out += ' { keyword: \'' + ('pattern') + '\' , dataPath: (dataPath || \'\') + ' + (it.errorPath) + ' , schemaPath: "' + ($errSchemaPath) + '" , params: { pattern: \'' + (it.util.escapeQuotes($schema)) + '\' } ';
      if (it.opts.messages !== false) {
        out += ' , message: \'should match pattern "' + (it.util.escapeQuotes($schema)) + '"\' ';
      }
      if (it.opts.verbose) {
        out += ' , schema: ' + (it.util.toQuotedString($schema)) + ' , parentSchema: validate.schema' + (it.schemaPath) + ' , data: ' + ($data) + ' ';
      }
      out += ' } ';
    } else {
      out += ' \'' + ('pattern') + '\' ';
    }
    out += '; if (vErrors === null) vErrors = [err]; else vErrors.push(err); errors++; ';
  }
  out += '} ';
  if ($breakOnError) {
    out += ' else { ';
  }
  return out;
}
